function varargout = EZDashboard(varargin)
% EZDASHBOARD M-file for EZDashboard.fig
%      EZDASHBOARD, by itself, creates a new EZDASHBOARD or raises the existing
%      singleton*.
%
%      H = EZDASHBOARD returns the handle to a new EZDASHBOARD or the handle to
%      the existing singleton*.
%
%      EZDASHBOARD('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EZDASHBOARD.M with the given input arguments.
%
%      EZDASHBOARD('Property','Value',...) creates a new EZDASHBOARD or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before EZDashboard_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to EZDashboard_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help EZDashboard

% Last Modified by GUIDE v2.5 09-Sep-2009 22:03:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @EZDashboard_OpeningFcn, ...
                   'gui_OutputFcn',  @EZDashboard_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before EZDashboard is made visible.
function EZDashboard_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to EZDashboard (see VARARGIN)

% Choose default command line output for EZDashboard
handles.output = hObject;
%Add fields in handles
handles.s = 0; 
handles.PortObjVar = 1;

%PARSE INPUT LINE
property_argin = varargin;
while (length(property_argin) >= 2)
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'PortObj'
        if(strcmp(class(val),'serial'))
            handles.s = val; 
            handles.PortObjVar = 0;
            COMPort = val.Port; 
            set(handles.btnLaunchFW,'Enable','on');
            set(handles.btnLaunchFD,'Enable','on');
            set(handles.btnLaunchXY,'Enable','on');
            set(handles.btnLaunchEZStepper,'Enable','on');
        else
            COMPort = '?';
        end
        set(handles.txtComport,'String',COMPort);
        set(handles.txtComport,'Enable','off');
        set(handles.btnOpenPort,'Enable','off');
        set(handles.btnClosePort,'Enable','off');
    end
end
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes EZDashboard wait for user response (see UIRESUME)
% uiwait(handles.figEZDashboard);


% --- Outputs from this function are returned to the command line.
function varargout = EZDashboard_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object deletion, before destroying properties.
function figEZDashboard_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figEZDashboard (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s; 
if(strcmp(class(s),'serial')&&(handles.PortObjVar == 1))
    [error] = EZStepperCloseSerial(s);
    set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
    handles.s = 0;
end
guidata(hObject,handles); % store the changes


function txtComport_Callback(hObject, eventdata, handles)
% hObject    handle to txtComport (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtComport as text
%        str2double(get(hObject,'String')) returns contents of txtComport as a double


% --- Executes during object creation, after setting all properties.
function txtComport_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtComport (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnOpenPort.
function btnOpenPort_Callback(hObject, eventdata, handles)
% hObject    handle to btnOpenPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
comport = get(handles.txtComport,'String');
[s,error] = EZStepperOpenSerial(comport);
msg = ['Open Port, error = ' num2str(error)];
set(handles.txtMessage,'String',msg);
if(error~=0), return; end
handles.s = s;
guidata(hObject,handles); % store the changes
set(handles.txtComport,'Enable','off');
set(handles.btnClosePort,'Enable','on');
set(handles.btnOpenPort,'Enable','off');
set(handles.btnLaunchFW,'Enable','on');
set(handles.btnLaunchFD,'Enable','on');
set(handles.btnLaunchXY,'Enable','on');
set(handles.btnLaunchEZStepper,'Enable','on');


% --- Executes on button press in btnClosePort.
function btnClosePort_Callback(hObject, eventdata, handles)
% hObject    handle to btnClosePort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s;
%delete port  
if(strcmp(class(s),'serial'))
    [error] = EZStepperCloseSerial(s);
    set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
    handles.s = 0;
end
guidata(hObject,handles); % store the changes
set(handles.txtComport,'Enable','on');
set(handles.btnClosePort,'Enable','off');
set(handles.btnOpenPort,'Enable','on');
set(handles.btnLaunchFW,'Enable','off');
set(handles.btnLaunchFD,'Enable','off');
set(handles.btnLaunchXY,'Enable','off');
set(handles.btnLaunchEZStepper,'Enable','off');


% --- Executes on button press in btnLaunchFW.
function btnLaunchFW_Callback(hObject, eventdata, handles)
% hObject    handle to btnLaunchFW (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s;
FilterWheel_UI('PortObj', s);

% --- Executes on button press in btnLaunchFD.
function btnLaunchFD_Callback(hObject, eventdata, handles)
% hObject    handle to btnLaunchFD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s;
FocusDrive_UI('PortObj', s);

% --- Executes on button press in btnLaunchXY.
function btnLaunchXY_Callback(hObject, eventdata, handles)
% hObject    handle to btnLaunchXY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s;

% --- Executes on button press in btnLaunchEZStepper.
function btnLaunchEZStepper_Callback(hObject, eventdata, handles)
% hObject    handle to btnLaunchEZStepper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s;
EZStepper_UI('PortObj', s);

function txtMessage_Callback(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMessage as text
%        str2double(get(hObject,'String')) returns contents of txtMessage as a double


% --- Executes during object creation, after setting all properties.
function txtMessage_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


