function [serialobj, error] = EZStepperOpenSerial(comport)
%OPEN SERIAL PORT comport. comport is a string, e.g. 'COM9'
global EZStepperLog
crlf=sprintf('\n');
EZStepperLog = [datestr(clock,0) crlf];

try
    serialobj = serial(comport, 'BaudRate',9600, 'Parity','none', 'StopBits',1, 'Terminator','CR');
    fopen(serialobj);
    if(nargout>1)
        error = 0;
    end
catch ME
    EZStepperLog = [EZStepperLog 'serial,fopen failed' crlf ME.message crlf];
    if(nargout>1)
        error = 1;
    end
end