function varargout = EZStepper_UI(varargin)
% EZSTEPPER_UI M-file for EZStepper_UI.fig
%      EZSTEPPER_UI, by itself, creates a new EZSTEPPER_UI or raises the existing
%      singleton*.
%
%      H = EZSTEPPER_UI returns the handle to a new EZSTEPPER_UI or the handle to
%      the existing singleton*.
%
%      EZSTEPPER_UI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EZSTEPPER_UI.M with the given input arguments.
%
%      EZSTEPPER_UI('Property','Value',...) creates a new EZSTEPPER_UI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before EZStepper_UI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to EZStepper_UI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help EZStepper_UI

% Last Modified by GUIDE v2.5 29-Apr-2009 18:38:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @EZStepper_UI_OpeningFcn, ...
                   'gui_OutputFcn',  @EZStepper_UI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before EZStepper_UI is made visible.
function EZStepper_UI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to EZStepper_UI (see VARARGIN)

% Choose default command line output for EZStepper_UI
handles.output = hObject;

%Add fields in handles
handles.m = 0;
handles.s = 0; 
handles.PortObjVar = 1;
handles.ControllerNameVar = 1;

%PARSE INPUT LINE
property_argin = varargin;
while (length(property_argin) >= 2)
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'PortObj'
        if(strcmp(class(val),'serial'))
            handles.s = val; 
            handles.PortObjVar = 0;
            COMPort = val.Port; 
            set(handles.btnCreateObject,'Enable','on');
        else
            COMPort = '?';
        end
        set(handles.txtComport,'String',COMPort);
        set(handles.txtComport,'Enable','off');
        set(handles.btnOpenPort,'Enable','off');
        set(handles.btnClosePort,'Enable','off');
    case 'ControllerName'
        set(handles.txtMnum,'String',num2str(val)); set(handles.txtMnum,'Enable','off');
        handles.ControllerNameVar = 0;
    case 'Timeout'
        set(handles.txtTimeout,'String',num2str(val)); set(handles.txtTimeout,'Enable','off');
    case 'LimitPolarity'
        set(handles.txtLimPol,'String',num2str(val)); set(handles.txtLimPol,'Enable','off');
    case 'LimitEnable'
        set(handles.txtEnableLim,'String',num2str(val)); set(handles.txtEnableLim,'Enable','off'); 
    case 'HoldCurrent'
        set(handles.txtHoldCurrent,'String',num2str(val)); set(handles.txtHoldCurrent,'Enable','off');
    case 'RunCurrent'
        set(handles.txtRunCurrent,'String',num2str(val)); set(handles.txtRunCurrent,'Enable','off');
    case 'StepDivide'
        set(handles.txtDivide,'String',num2str(val)); set(handles.txtDivide,'Enable','off');
    case 'SlewVelocity'
        set(handles.txtSlewVelo,'String',num2str(val)); set(handles.txtSlewVelo,'Enable','off');
    case 'InitVelocity'
        set(handles.txtInitVelo,'String',num2str(val)); set(handles.txtInitVelo,'Enable','off');
    case 'Ramp'
        set(handles.txtRamp,'String',num2str(val)); set(handles.txtRamp,'Enable','off');
    case 'Log'
        set(handles.radLog,'Value',val); set(handles.radLog,'Enable','off');
    end
end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes EZStepper_UI wait for user response (see UIRESUME)
% uiwait(handles.figEZStepper_UI);


% --- Outputs from this function are returned to the command line.
function varargout = EZStepper_UI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function txtComport_Callback(hObject, eventdata, handles)
% hObject    handle to txtComport (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtComport as text
%        str2double(get(hObject,'String')) returns contents of txtComport as a double


% --- Executes during object creation, after setting all properties.
function txtComport_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtComport (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnCreateObject.
function btnCreateObject_Callback(hObject, eventdata, handles)
% hObject    handle to btnCreateObject (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Read values from the interface
mname = str2double(get(handles.txtMnum,'String'));
if(~isnan(mname))
    ControllerName = mname;
else
    set(handles.txtMessage,'String','ControllerName is not a number');
    return;
end

tout = str2double(get(handles.txtTimeout,'String'));
if(~isnan(tout))
    Timeout = tout;
else
    Timeout = 30;
end

div = str2double(get(handles.txtDivide,'String'));
if(~isnan(div))
    Divide = div;
else
    Divide = 256;
end

initvelo = str2double(get(handles.txtInitVelo,'String'));
if(~isnan(initvelo))
    InitVelocity = initvelo;
else
    InitVelocity = 10000;
end

slewvelo = str2double(get(handles.txtSlewVelo,'String'));
if(~isnan(slewvelo)) 
    SlewVelocity = slewvelo;
else
    SlewVelocity = 100000;
end

r = str2double(get(handles.txtRamp,'String'));
if(~isnan(r)) 
    Ramp = r;
else
    Ramp = 1000;
end

limpol = str2double(get(handles.txtLimPol,'String'));
if(~isnan(limpol)) 
    LimitPolarity = limpol;
else
    LimitPolarity = 0;
end

hcurrent = str2double(get(handles.txtHoldCurrent,'String'));
if(~isnan(hcurrent)) 
    HoldCurrent = hcurrent;
else
    HoldCurrent = 10;
end

rcurrent = str2double(get(handles.txtRunCurrent,'String'));
if(~isnan(rcurrent)) 
    RunCurrent = rcurrent;
else
    RunCurrent = 25;
end

enable = str2double(get(handles.txtEnableLim,'String'));
if(~isnan(enable)) 
    LimitEnable = enable;
else
    LimitEnable = 1;
end

log = get(handles.radLog,'Value');
if(log==1)
    Log = 1;
else
    Log = 0;
end

%Create EZStepper object
s = handles.s;
m = EZStepper('PortObj',s,'ControllerName',ControllerName,'Timeout',Timeout,'LimitEnable',LimitEnable, ...
    'StepDivide',Divide,'SlewVelocity',SlewVelocity, 'InitVelocity',InitVelocity,'Ramp',Ramp, ...
    'LimitPolarity',LimitPolarity,'HoldCurrent',HoldCurrent,'RunCurrent',RunCurrent,'Log',Log);
handles.m = m;
error = get(m,'LastErr');
guidata(hObject,handles); % store the changes
msg = ['EZStepper Object Created, LastErr = ' num2str(error)];
set(handles.txtMessage,'String',msg);

if(error==0)
    set(handles.btnDeleteObject,'Enable','on');
    set(handles.txtComport,'Enable','off');
    set(handles.txtMnum,'Enable','off');
    set(hObject,'Enable','off');  
    set(handles.btnDirectCmd,'Enable','on');
    set(handles.btnTimeoutSet,'Enable','on');
    set(handles.btnDivideSet,'Enable','on');
    set(handles.btnInitVeloSet,'Enable','on');
    set(handles.btnSlewVeloSet,'Enable','on');
    set(handles.btnRampSet,'Enable','on');
    set(handles.btnCurrentSet,'Enable','on');
    set(handles.btnEnableLimSet,'Enable','on');
    set(handles.btnLimPolSet,'Enable','on');
    set(handles.btnStop,'Enable','on');
    set(handles.btnMoveRel,'Enable','on');
    set(handles.btnMoveAbs,'Enable','on');
    set(handles.btnHome,'Enable','on');
    set(handles.btnToLim,'Enable','on');
    set(handles.btnReadPos,'Enable','on');
    set(handles.btnReadHrdwr,'Enable','on');
    set(handles.btnReadLimits,'Enable','on');
    set(handles.btnReadSlewVelo,'Enable','on');
    set(handles.btnReadMoving,'Enable','on');
    set(handles.radOut1,'Enable','on');
    set(handles.radOut2,'Enable','on');
    set(handles.radJog,'Enable','on');
    set(handles.txtJogSpeed,'Enable','on');
    set(handles.sldJogSpeed,'Enable','on');
    set(handles.btnSetOrigin,'Enable','on');
    set(handles.btnClosePort,'Enable','off');
end


function txtMnum_Callback(hObject, eventdata, handles)
% hObject    handle to txtMnum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMnum as text
%        str2double(get(hObject,'String')) returns contents of txtMnum as a double


% --- Executes during object creation, after setting all properties.
function txtMnum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMnum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtDirectCmd_Callback(hObject, eventdata, handles)
% hObject    handle to txtDirectCmd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtDirectCmd as text
%        str2double(get(hObject,'String')) returns contents of txtDirectCmd as a double


% --- Executes during object creation, after setting all properties.
function txtDirectCmd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtDirectCmd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnDeleteObject.
function btnDeleteObject_Callback(hObject, eventdata, handles)
% hObject    handle to btnDeleteObject (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%delete EZStepper objects 
m = handles.m;
if(strcmp(class(m),'EZStepper'))
    delete(m);
    clear m;
    handles.m = 0;
end
guidata(hObject,handles); % store the changes

set(handles.btnCreateObject,'Enable','on');
if(handles.ControllerNameVar == 1), set(handles.txtMnum,'Enable','on'); end
set(hObject,'Enable','off');
set(handles.btnDirectCmd,'Enable','off');
set(handles.btnTimeoutSet,'Enable','off');
set(handles.btnDivideSet,'Enable','off');
set(handles.btnInitVeloSet,'Enable','off');
set(handles.btnSlewVeloSet,'Enable','off');
set(handles.btnRampSet,'Enable','off');
set(handles.btnCurrentSet,'Enable','off');
set(handles.btnEnableLimSet,'Enable','off');
set(handles.btnLimPolSet,'Enable','off');
set(handles.btnStop,'Enable','off');
set(handles.btnMoveRel,'Enable','off');
set(handles.btnMoveAbs,'Enable','off');
set(handles.btnHome,'Enable','off');
set(handles.btnToLim,'Enable','off');
set(handles.btnReadPos,'Enable','off');
set(handles.btnReadHrdwr,'Enable','off');
set(handles.btnReadLimits,'Enable','off');
set(handles.btnReadSlewVelo,'Enable','off');
set(handles.btnReadMoving,'Enable','off');
set(handles.radOut1,'Enable','off');
set(handles.radOut2,'Enable','off');
set(handles.radJog,'Enable','off');
set(handles.txtJogSpeed,'Enable','off');
set(handles.sldJogSpeed,'Enable','off');
set(handles.btnSetOrigin,'Enable','off');
if(handles.PortObjVar == 1), set(handles.btnClosePort,'Enable','on'); end

set(handles.txtMessage,'String','EZStepper Object Deleted');

% --- Executes on button press in radLog.
function radLog_Callback(hObject, eventdata, handles)
% hObject    handle to radLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radLog
if(strcmp(class(handles.m),'EZStepper'))
    m = handles.m;
    v = get(hObject,'Value');
    %m.Log = v;
    set(m,'Log',v);
    handles.m = m;
    guidata(hObject,handles); % store the changes
end


% --- Executes on selection change in mnuRecall.
function mnuRecall_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRecall (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns mnuRecall contents as cell array
%        contents{get(hObject,'Value')} returns selected item from mnuRecall
val = get(hObject,'Value');
string_list = get(hObject,'String');
selected_string = string_list{val}; % convert from cell array to string
set(handles.txtDirectCmd,'String',selected_string);


% --- Executes during object creation, after setting all properties.
function mnuRecall_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mnuRecall (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnDirectCmd.
function btnDirectCmd_Callback(hObject, eventdata, handles)
% hObject    handle to btnDirectCmd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
command = get(handles.txtDirectCmd,'String');
m = handles.m;
[response,error] = MotorCmndRspn(m, command);
set(handles.txtMessage,'String',['Response ' response ', error = ' num2str(error)]);
%REMEMBER COMMAND
cmd_list = get(handles.mnuRecall,'String');
if(iscell(cmd_list))
    cmd_list = [{command}; cmd_list];
else
    cmd_list = {command};
end
set(handles.mnuRecall,'String',cmd_list);


function txtTimeout_Callback(hObject, eventdata, handles)
% hObject    handle to txtTimeout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtTimeout as text
%        str2double(get(hObject,'String')) returns contents of txtTimeout as a double


% --- Executes during object creation, after setting all properties.
function txtTimeout_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtTimeout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnTimeoutSet.
function btnTimeoutSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnTimeoutSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tout = str2double(get(handles.txtTimeout,'String'));
if(~isnan(tout))
    m = handles.m;
    %m.Timeout = tout;
    set(m,'Timeout',tout);
    %handles.m = m;
    %guidata(hObject,handles); % store the changes
    error = get(m,'LastErr');
    set(handles.txtMessage,'String',['Timeout ' num2str(tout) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Timeout is Not a Number;'); drawnow
end

function txtDivide_Callback(hObject, eventdata, handles)
% hObject    handle to txtDivide (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtDivide as text
%        str2double(get(hObject,'String')) returns contents of txtDivide as a double


% --- Executes during object creation, after setting all properties.
function txtDivide_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtDivide (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnDivideSet.
function btnDivideSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnDivideSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
divide = str2double(get(handles.txtDivide,'String'));
if(~isnan(divide))
    m = handles.m;
    set(m,'StepDivide',divide);
    error = get(m,'LastErr');
    set(handles.txtMessage,'String',['Set Microstep Divide ' num2str(divide) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Microstep Divide is Not a Number');
end


function txtInitVelo_Callback(hObject, eventdata, handles)
% hObject    handle to txtInitVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtInitVelo as text
%        str2double(get(hObject,'String')) returns contents of txtInitVelo as a double


% --- Executes during object creation, after setting all properties.
function txtInitVelo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtInitVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnInitVeloSet.
function btnInitVeloSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnInitVeloSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
initvelo = str2double(get(handles.txtInitVelo,'String'));
m = handles.m;
if(~isnan(initvelo)) 
    set(m,'InitVelocity',initvelo);
    error = get(m,'LastErr');
    set(handles.txtMessage,'String',['Set Initial Velocity ' num2str(initvelo) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Initial Velocity is Not a Number');
end


function txtSlewVelo_Callback(hObject, eventdata, handles)
% hObject    handle to txtSlewVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtSlewVelo as text
%        str2double(get(hObject,'String')) returns contents of txtSlewVelo as a double


% --- Executes during object creation, after setting all properties.
function txtSlewVelo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtSlewVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnSlewVeloSet.
function btnSlewVeloSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnSlewVeloSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
slewvelo = str2double(get(handles.txtSlewVelo,'String'));
m = handles.m;
if(~isnan(slewvelo)) 
    set(m,'SlewVelocity',slewvelo);
    error = get(m,'LastErr'); %error = m.LastErr;
    set(handles.txtMessage,'String',['Set Slew Velocity ' num2str(slewvelo) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Slew Velocity is Not a Number');
end



function txtRamp_Callback(hObject, eventdata, handles)
% hObject    handle to txtRamp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtRamp as text
%        str2double(get(hObject,'String')) returns contents of txtRamp as a double


% --- Executes during object creation, after setting all properties.
function txtRamp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtRamp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnRampSet.
function btnRampSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnRampSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ramp = str2double(get(handles.txtRamp,'String'));
m = handles.m;
if(~isnan(ramp))
    set(m,'Ramp',ramp);
    error = get(m,'LastErr');
    set(handles.txtMessage,'String',['Set Ramp ' num2str(ramp) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Ramp is Not a Number');
end


function txtHoldCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to txtHoldCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtHoldCurrent as text
%        str2double(get(hObject,'String')) returns contents of txtHoldCurrent as a double


% --- Executes during object creation, after setting all properties.
function txtHoldCurrent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtHoldCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtRunCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to txtRunCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtRunCurrent as text
%        str2double(get(hObject,'String')) returns contents of txtRunCurrent as a double


% --- Executes during object creation, after setting all properties.
function txtRunCurrent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtRunCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnCurrentSet.
function btnCurrentSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnCurrentSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hcurrent = str2double(get(handles.txtHoldCurrent,'String'));
rcurrent = str2double(get(handles.txtRunCurrent,'String'));
m = handles.m;
if((~isnan(hcurrent))&&(~isnan(rcurrent))) 
    set(m,'HoldCurrent',hcurrent);
    herror = get(m,'LastErr');
    set(m,'RunCurrent',rcurrent); 
    rerror = get(m,'LastErr');
    set(handles.txtMessage,'String',['Set Hold and Run Current ' num2str(hcurrent) ', ' num2str(rcurrent) ', error = ' num2str(herror+rerror)]);
else
    set(handles.txtMessage,'String','Hold and/or Run Current is Not a Number');
end


function txtEnableLim_Callback(hObject, eventdata, handles)
% hObject    handle to txtEnableLim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtEnableLim as text
%        str2double(get(hObject,'String')) returns contents of txtEnableLim as a double


% --- Executes during object creation, after setting all properties.
function txtEnableLim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtEnableLim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnEnableLimSet.
function btnEnableLimSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnEnableLimSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
enable = str2double(get(handles.txtEnableLim,'String'));
m = handles.m;
if(~isnan(enable))
    set(m,'LimitEnable',enable);
    error = get(m,'LastErr');
    set(handles.txtMessage,'String',['Enable Limits ' num2str(enable) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Enable is Not a Number');
end


function txtLimPol_Callback(hObject, eventdata, handles)
% hObject    handle to txtLimPol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtLimPol as text
%        str2double(get(hObject,'String')) returns contents of txtLimPol as a double


% --- Executes during object creation, after setting all properties.
function txtLimPol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtLimPol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnLimPolSet.
function btnLimPolSet_Callback(hObject, eventdata, handles)
% hObject    handle to btnLimPolSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
limpol = str2double(get(handles.txtLimPol,'String'));
m = handles.m;
if(~isnan(limpol)) 
    set(m,'LimitPolarity',limpol);
    error = get(m,'LastErr');
    set(handles.txtMessage,'String',['Limit Polarity ' num2str(limpol) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Limit Polarity is Not a Number');
end

% --- Executes on button press in btnPrintLog.
function btnPrintLog_Callback(hObject, eventdata, handles)
% hObject    handle to btnPrintLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
log = EZStepperLog

% --- Executes on button press in btnClearLog.
function btnClearLog_Callback(hObject, eventdata, handles)
% hObject    handle to btnClearLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
EZStepperClearLog;

% --- Executes on button press in btnPrintObj.
function btnPrintObj_Callback(hObject, eventdata, handles)
% hObject    handle to btnPrintObj (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
m

% --- Executes on button press in radOut1.
function radOut1_Callback(hObject, eventdata, handles)
% hObject    handle to radOut1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radOut1
m = handles.m;
out1 = get(hObject,'Value');
out2 = get(handles.radOut2,'Value');
out = out1+2*out2;
error = MotorOutputs(m,out);
set(handles.txtMessage,'String',['Set Outputs, error = ' num2str(error)]);


% --- Executes on button press in radOut2.
function radOut2_Callback(hObject, eventdata, handles)
% hObject    handle to radOut2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radOut2
m = handles.m;
out1 = get(handles.radOut1,'Value');
out2 = get(hObject,'Value');
out = out1+2*out2;
error = MotorOutputs(m,out);
set(handles.txtMessage,'String',['Set Outputs, error = ' num2str(error)]);


% --- Executes on button press in radJog.
function radJog_Callback(hObject, eventdata, handles)
% hObject    handle to radJog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radJog
m = handles.m;
jval = get(hObject,'Value');
if(jval~=0)
    jspeed = get(handles.sldJogSpeed,'Value');
    jspeed = fix(jspeed);
    error = MotorJog(m,jspeed);
    set(handles.txtMessage,'String',['Jog, error = ' num2str(error)]);
else
    error = MotorJog(m,0);
    set(handles.txtMessage,'String',['Stop, error = ' num2str(error)]);
end


function txtJogSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to txtJogSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtJogSpeed as text
%        str2double(get(hObject,'String')) returns contents of txtJogSpeed as a double
jspeed = str2double(get(hObject,'String'));
jspmin = get(handles.sldJogSpeed,'Min');
jspmax = get(handles.sldJogSpeed,'Max');
if(isnan(jspeed))
    set(handles.txtMessage,'String','Bad Jog Speed');    
    return;
end
if(jspeed>jspmax)
    jspeed=jspmax;
    set(handles.txtMessage,'String','Jog Speed > Max in Slider');    
end
if(jspeed<jspmin)
    jspeed=jspmin;
    set(handles.txtMessage,'String','Jog Speed < Min in Slider');    
end
set(handles.sldJogSpeed,'Value',jspeed);


% --- Executes during object creation, after setting all properties.
function txtJogSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtJogSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function sldJogSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to sldJogSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
persistent oldjsp;
if(isempty(oldjsp))
    oldjsp = 0;
end
jspeed = get(hObject,'Value');
jspeed = fix(jspeed);
m = handles.m;
jval = get(handles.radJog,'Value');
set(handles.txtJogSpeed,'String',[num2str(jspeed)]);
if(jval==1)
    if(oldjsp*jspeed<0)
        MotorJog(m,0);
        MotorWait(m);
    end
    error = MotorJog(m,jspeed);
    set(handles.txtMessage,'String',['Jog, error = ' num2str(error)]);
end
oldjsp = jspeed;


% --- Executes during object creation, after setting all properties.
function sldJogSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sldJogSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in btnStop.
function btnStop_Callback(hObject, eventdata, handles)
% hObject    handle to btnStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
error = MotorJog(m,0);
set(handles.txtMessage,'String',['Stop, error = ' num2str(error)]);
set(handles.radJog,'Value',0);


% --- Executes on button press in btnMoveRel.
function btnMoveRel_Callback(hObject, eventdata, handles)
% hObject    handle to btnMoveRel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
travel = str2double(get(handles.txtMoveRel,'String'));
m = handles.m;
if(~isnan(travel) && strcmp(class(m),'EZStepper')) 
    error = MotorMoveRel(m,travel);
    set(handles.txtMessage,'String',['Move Rel ' num2str(travel) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Travel is Not a Number');
end


% --- Executes on button press in btnSetOrigin.
function btnSetOrigin_Callback(hObject, eventdata, handles)
% hObject    handle to btnSetOrigin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
error = MotorSetOrigin(m);
set(handles.txtMessage,'String',['Set origin, error = ' num2str(error)]);
set(handles.radJog,'Value',0);


function txtMoveRel_Callback(hObject, eventdata, handles)
% hObject    handle to txtMoveRel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMoveRel as text
%        str2double(get(hObject,'String')) returns contents of txtMoveRel as a double


% --- Executes during object creation, after setting all properties.
function txtMoveRel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMoveRel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnMoveAbs.
function btnMoveAbs_Callback(hObject, eventdata, handles)
% hObject    handle to btnMoveAbs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
destination = str2double(get(handles.txtMoveAbs,'String'));
m = handles.m;
if(~isnan(destination)) 
    error = MotorMoveAbs(m,destination);
    set(handles.txtMessage,'String',['Move Abs ' num2str(destination) ', error = ' num2str(error)]);
else
    set(handles.txtMessage,'String','Destination is Not a Number');
end


function txtMoveAbs_Callback(hObject, eventdata, handles)
% hObject    handle to txtMoveAbs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMoveAbs as text
%        str2double(get(hObject,'String')) returns contents of txtMoveAbs as a double


% --- Executes during object creation, after setting all properties.
function txtMoveAbs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMoveAbs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnHome.
function btnHome_Callback(hObject, eventdata, handles)
% hObject    handle to btnHome (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
speed = str2double(get(handles.txtHomeSpeed,'String'));
m = handles.m;
if(isnan(speed))
    [slewvelo,error] = MotorReadSlewVelo(m);
    if(error==0)
        speed = slewvelo;
    else
        return
    end
end
set(handles.txtMessage,'String','Homing ... ');
drawnow
error = MotorHomeComplete(m,speed);
set(handles.txtMessage,'String',['Home Finished, error = ' num2str(error)]);


% --- Executes on button press in btnToLim.
function btnToLim_Callback(hObject, eventdata, handles)
% hObject    handle to btnToLim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
speed = str2double(get(handles.txtHomeSpeed,'String'));
m = handles.m;
if(isnan(speed))
    [slewvelo,error] = MotorReadSlewVelo(m);
    if(error==0)
        speed = slewvelo;
    else
        return
    end
end
set(handles.txtMessage,'String','To Limit ... ');
drawnow
[limits,error] = MotorToLimit(m,speed);
set(handles.txtMessage,'String',['To Limit Finished, limit = ' num2str(limits) ', error = ' num2str(error)]);


function txtHomeSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to txtHomeSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtHomeSpeed as text
%        str2double(get(hObject,'String')) returns contents of txtHomeSpeed as a double


% --- Executes during object creation, after setting all properties.
function txtHomeSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtHomeSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnReadPos.
function btnReadPos_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
[position,error] = MotorReadPosition(m);
set(handles.txtReadPos,'String',num2str(position));
set(handles.txtMessage,'String',['Read Position, error = ' num2str(error)]);


function txtReadPos_Callback(hObject, eventdata, handles)
% hObject    handle to txtReadPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtReadPos as text
%        str2double(get(hObject,'String')) returns contents of txtReadPos as a double


% --- Executes during object creation, after setting all properties.
function txtReadPos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtReadPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnReadHrdwr.
function btnReadHrdwr_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadHrdwr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
[hardwr,error] = MotorReadHardwr(m);
set(handles.txtReadHrdwr,'String',num2str(hardwr));
set(handles.txtMessage,'String',['Read All Switches, error = ' num2str(error)]);


function txtReadHrdwr_Callback(hObject, eventdata, handles)
% hObject    handle to txtReadHrdwr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtReadHrdwr as text
%        str2double(get(hObject,'String')) returns contents of txtReadHrdwr as a double


% --- Executes during object creation, after setting all properties.
function txtReadHrdwr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtReadHrdwr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnReadLimits.
function btnReadLimits_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
[limits,error] = MotorReadLimits(m);
set(handles.txtReadLimits,'String',num2str(limits));
set(handles.txtMessage,'String',['Read Optical Switches, error = ' num2str(error)]);


function txtReadLimits_Callback(hObject, eventdata, handles)
% hObject    handle to txtReadLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtReadLimits as text
%        str2double(get(hObject,'String')) returns contents of txtReadLimits as a double


% --- Executes during object creation, after setting all properties.
function txtReadLimits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtReadLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnReadSlewVelo.
function btnReadSlewVelo_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadSlewVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
[slewvelo,error] = MotorReadSlewVelo(m);
set(handles.txtReadSlewVelo,'String',num2str(slewvelo));
set(handles.txtMessage,'String',['Slew Velocity, error = ' num2str(error)]);


function txtReadSlewVelo_Callback(hObject, eventdata, handles)
% hObject    handle to txtReadSlewVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtReadSlewVelo as text
%        str2double(get(hObject,'String')) returns contents of txtReadSlewVelo as a double


% --- Executes during object creation, after setting all properties.
function txtReadSlewVelo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtReadSlewVelo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnReadMoving.
function btnReadMoving_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadMoving (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
[moving,error] = MotorMoveStatus(m);
set(handles.txtReadMoving,'String',num2str(moving));
set(handles.txtMessage,'String',['Moving Status, error = ' num2str(error)]);


function txtReadMoving_Callback(hObject, eventdata, handles)
% hObject    handle to txtReadMoving (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtReadMoving as text
%        str2double(get(hObject,'String')) returns contents of txtReadMoving as a double


% --- Executes during object creation, after setting all properties.
function txtReadMoving_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtReadMoving (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function txtMessage_Callback(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMessage as text
%        str2double(get(hObject,'String')) returns contents of txtMessage as a double


% --- Executes during object creation, after setting all properties.
function txtMessage_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object deletion, before destroying properties.
function figEZStepper_UI_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figEZStepper_UI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m = handles.m;
if(strcmp(class(m),'EZStepper')) 
    delete(m);
    clear m;
    handles.m = 0;
end
s = handles.s; 
if(strcmp(class(s),'serial')&&(handles.PortObjVar == 1))
    [error] = EZStepperCloseSerial(s);
    set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
    handles.s = 0;
end
guidata(hObject,handles); % store the changes


% --- Executes on button press in btnOpenPort.
function btnOpenPort_Callback(hObject, eventdata, handles)
% hObject    handle to btnOpenPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
comport = get(handles.txtComport,'String');
[s,error] = EZStepperOpenSerial(comport);
msg = ['Open Port, error = ' num2str(error)];
set(handles.txtMessage,'String',msg);
if(error~=0), return; end
handles.s = s;
guidata(hObject,handles); % store the changes
set(handles.txtComport,'Enable','off');
set(handles.btnClosePort,'Enable','on');
set(handles.btnOpenPort,'Enable','off');
set(handles.btnCreateObject,'Enable','on');
set(handles.btnDeleteObject,'Enable','off');

% --- Executes on button press in btnClosePort.
function btnClosePort_Callback(hObject, eventdata, handles)
% hObject    handle to btnClosePort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s = handles.s;
%delete port  
if(strcmp(class(s),'serial'))
    [error] = EZStepperCloseSerial(s);
    set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
    handles.s = 0;
end
guidata(hObject,handles); % store the changes
set(handles.txtComport,'Enable','on');
set(handles.btnClosePort,'Enable','off');
set(handles.btnOpenPort,'Enable','on');
set(handles.btnCreateObject,'Enable','off');

