function varargout = FilterWheel_UI(varargin)
% FilterWheel_UI M-file for FilterWheel_UI.fig
%      FilterWheel_UI, by itself, creates a new FilterWheel_UI or raises the existing
%      singleton*.
%
%      H = FilterWheel_UI returns the handle to a new FilterWheel_UI or the handle to
%      the existing singleton*.
%
%      FilterWheel_UI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FilterWheel_UI.M with the given input arguments.
%
%      FilterWheel_UI('Property','Value',...) creates a new FilterWheel_UI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FilterWheel_UI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FilterWheel_UI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FocusDrive_UI

% Last Modified by GUIDE v2.5 06-May-2009 13:03:53

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FilterWheel_UI_OpeningFcn, ...
                   'gui_OutputFcn',  @FilterWheel_UI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FocusDrive_UI is made visible.
function FilterWheel_UI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FocusDrive_UI (see VARARGIN)

% Choose default command line output for FocusDrive_UI
handles.output = hObject;

%ADD FIELDS IN handles WITH DEFAULT VALUES
handles.fw = 0;
handles.PortObj = NaN; %port object;
handles.COMPort = 'COM4';
handles.PortObjVar = 1; 
handles.ControllerType = 'EZHR17'; %supported: EZHR17
handles.ControllerTypeVar = 1;
handles.ControllerName = 1; %name or number of controller on this port
handles.ControllerNameVar = 1;
handles.MotorSteps = 200; %physical steps in the motor; typically 200
handles.MotorStepsVar = 1;
handles.FilterPositions = 12; 
handles.FilterPositionsVar = 1;
handles.OffsetFromHome = -2; 
handles.OffsetFromHomeVar = 1;
handles.HoldCurrent = 5; %current when not moving; in % of full (2A for EZHR17); typically 5%
handles.HoldCurrentVar = 1;
handles.RunCurrent = 50; %current when moving; in % of full (2A for EZHR17); typically 25%
handles.RunCurrentVar = 1;
handles.StepDivide = 16; %number of microsteps per step; typically 256
handles.StepDivideVar = 1;
handles.SlewVelocity = 10000; %slew (max) velocity in microsteps/sec 
handles.SlewVelocityVar = 1;
handles.InitVelocity = 100; %initial velocity in microsteps/sec 
handles.InitVelocityVar = 1;
handles.Ramp = 12; %acceleration (deceleration) in microsteps/sec^2 
handles.RampVar = 1;
handles.Log = 1; %0 - do not accumulate log; 1 - accumulate log
handles.LogVar = 1;

%READ PARAMETER VALUES
try
    load FilterWheel.mat;
    handles.COMPort = COMPort;
    handles.ControllerType = ControllerType;
    handles.ControllerName = ControllerName;
    handles.MotorSteps = MotorSteps;
    handles.FilterPositions = FilterPositions;
    handles.OffsetFromHome = OffsetFromHome;  
    handles.HoldCurrent = HoldCurrent;
    handles.RunCurrent = RunCurrent;
    handles.StepDivide = StepDivide;
    handles.SlewVelocity = SlewVelocity;
    handles.InitVelocity = InitVelocity;
    handles.Ramp = Ramp;
    handles.Log = Log;
    set(handles.txtMessage,'String','Parameters read'); 
catch ME
   set(handles.txtMessage,'String','Parameter file was not read; using defaults'); 
end

%PARSE INPUT LINE
property_argin = varargin;
while (length(property_argin) >= 2)
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'PortObj'
        handles.PortObj = val; handles.PortObjVar = 0; 
    case 'ControllerType'
        handles.ControllerType = val; handles.ControllerTypeVar = 0;
    case 'ControllerName'
        handles.ControllerName = val; handles.ControllerNameVar = 0;
    case 'MotorSteps'
        handles.MotorSteps = val; handles.MotorStepsVar = 0;
    case 'FilterPositions'
        handles.FilterPositions = val; handles.FilterPositionsVar = 0;
    case 'OffsetFromHome'
        handles.OffsetFromHome = val; handles.OffsetFromHomevar = 0;
    case 'HoldCurrent'
        handles.HoldCurrent = val; handles.HoldCurrentVar = 0;
    case 'RunCurrent'
        handles.RunCurrent = val; handles.RunCurrentVar = 0;
    case 'StepDivide'
        handles.StepDivide = val; handles.StepDivideVar = 0;
    case 'SlewVelocity'
        handles.SlewVelocity = val; handles.SlewVelocityVar = 0;
    case 'InitVelocity'
        handles.InitVelocity = val; handles.InitVelocityVar = 0;
    case 'Ramp'
        handles.Ramp = val; handles.RampVar = 0;
    case 'Log'
        handles.Log = val; handles.LogVar = 0;
    end
end

%Form menu labels
if(handles.PortObjVar == 1)
    set(handles.mnuPort,'Label',['Port = ', handles.COMPort]);
else    
    s = handles.PortObj; 
    if(strcmp(class(s),'serial'))
        handles.COMPort = s.Port; 
    else
        handles.COMPort = 'not a serial port';
    end
    set(handles.mnuPort,'Label',['Port = ', handles.COMPort]);
    set(handles.mnuPort,'Enable','off');
    set(handles.mnuOpenCOM,'Enable','off');
    set(handles.mnuCreateFW,'Enable','on');
end    
set(handles.mnuControllerType,'Label', ['ControllerType = ' handles.ControllerType]);
if(handles.ControllerTypeVar == 0), set(handles.mnuControllerType,'Enable','off'); end
set(handles.mnuControllerName,'Label', ['ControllerName = ' num2str(handles.ControllerName)]);
if(handles.ControllerNameVar == 0), set(handles.mnuControllerName,'Enable','off'); end
set(handles.mnuMotorSteps,'Label', ['MotorSteps = ' num2str(handles.MotorSteps)]);
if(handles.MotorStepsVar == 0), set(handles.mnuMotorSteps,'Enable','off'); end
set(handles.mnuFilterPositions,'Label', ['FilterPositions = ' num2str(handles.FilterPositions)]);
if(handles.FilterPositionsVar == 0), set(handles.mnuFilterPositions,'Enable','off'); end
set(handles.mnuOffsetFromHome,'Label', ['OffsetFromHome = ' num2str(handles.OffsetFromHome)]);
if(handles.OffsetFromHomeVar == 0), set(handles.mnuOffsetFromHome,'Enable','off'); end
set(handles.mnuHoldCurrent,'Label', ['HoldCurrent = ' num2str(handles.HoldCurrent)]);
if(handles.HoldCurrentVar == 0), set(handles.mnuHoldCurrent,'Enable','off'); end
set(handles.mnuRunCurrent,'Label', ['RunCurrent = ' num2str(handles.RunCurrent)]);
if(handles.RunCurrentVar == 0), set(handles.mnuRunCurrent,'Enable','off'); end
set(handles.mnuStepDivide,'Label', ['StepDivide = ' num2str(handles.StepDivide)]);
if(handles.StepDivideVar == 0), set(handles.mnuStepDivide,'Enable','off'); end
set(handles.mnuSlewVelocity,'Label', ['SlewVelocity = ' num2str(handles.SlewVelocity)]);
if(handles.SlewVelocityVar == 0), set(handles.mnuSlewVelocity,'Enable','off'); end
set(handles.mnuInitVelocity,'Label', ['InitVelocity = ' num2str(handles.InitVelocity)]);
if(handles.InitVelocityVar == 0), set(handles.mnuInitVelocity,'Enable','off'); end
set(handles.mnuRamp,'Label', ['Ramp = ' num2str(handles.Ramp)]);
if(handles.RampVar == 0), set(handles.mnuRamp,'Enable','off'); end
set(handles.mnuLog,'Label', ['Log = ' num2str(handles.Log)]);
if(handles.LogVar == 0), set(handles.mnuLog,'Enable','off'); end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FocusDrive_UI wait for user response (see UIRESUME)
% uiwait(handles.figFilterWheel);


% --- Outputs from this function are returned to the command line.
function varargout = FilterWheel_UI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function mnuPar_Callback(hObject, eventdata, handles)
% hObject    handle to mnuPar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuInit_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function mnuPort_Callback(hObject, eventdata, handles)
% hObject    handle to mnuPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
newc = inputdlg('Enter new value for COM Port','Port',1,{handles.COMPort});
drawnow;
if(~isempty(newc)) 
    handles.COMPort = newc{1}; 
    msg = ['Port = ', handles.COMPort];
    set(handles.mnuPort,'Label',msg);
    set(handles.txtMessage,'String',msg); 
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function mnuControllerType_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%ONLY ONE SUPPORTED

% --------------------------------------------------------------------
function mnuControllerName_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for ControllerName (Number)','ControllerName',1,{num2str(handles.ControllerName)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.ControllerName = newv; 
        msg = ['ControllerName = ', num2str(handles.ControllerName)];
        set(handles.mnuControllerName,'Label',msg);
        set(handles.txtMessage,'String',msg);
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuMotorSteps_Callback(hObject, eventdata, handles)
% hObject    handle to mnuMotorSteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for MotorSteps','MotorSteps',1,{num2str(handles.MotorSteps)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.MotorSteps = newv; 
        msg = ['MotorSteps = ', num2str(handles.MotorSteps)];
        set(handles.mnuMotorSteps,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end

% --------------------------------------------------------------------
function mnuFilterPositions_Callback(hObject, eventdata, handles)
% hObject    handle to mnuMotorSteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for FilterPositions','FilterPositions',1,{num2str(handles.FilterPositions)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.FilterPositions = newv; 
        msg = ['FilterPositions = ', num2str(handles.FilterPositions)];
        set(handles.mnuFilterPositions,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuHoldCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to mnuHoldCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for HoldCurrent','HoldCurrent',1,{num2str(handles.HoldCurrent)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.HoldCurrent = newv; 
        msg = ['HoldCurrent = ', num2str(handles.HoldCurrent)];
        set(handles.mnuHoldCurrent,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'HoldCurrent',newv);
        end
        guidata(hObject, handles);      
    end
end

% --------------------------------------------------------------------
function mnuRunCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRunCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for RunCurrent','RunCurrent',1,{num2str(handles.RunCurrent)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.RunCurrent = newv; 
        msg = ['RunCurrent = ', num2str(handles.RunCurrent)];
        set(handles.mnuRunCurrent,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'RunCurrent',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuStepDivide_Callback(hObject, eventdata, handles)
% hObject    handle to mnuStepDivide (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for StepDivide','StepDivide',1,{num2str(handles.StepDivide)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.StepDivide = newv; 
        msg = ['StepDivide = ', num2str(handles.StepDivide)];
        set(handles.mnuStepDivide,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'StepDivide',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuSlewVelocity_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSlewVelocity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for SlewVelocity','SlewVelocity',1,{num2str(handles.SlewVelocity)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.SlewVelocity = newv; 
        msg = ['SlewVelocity = ', num2str(handles.SlewVelocity)];
        set(handles.mnuSlewVelocity,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'SlewVelocity',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuInitVelocity_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInitVelocity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for InitVelocity','InitVelocity',1,{num2str(handles.InitVelocity)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.InitVelocity = newv; 
        msg = ['InitVelocity = ', num2str(handles.InitVelocity)];
        set(handles.mnuInitVelocity,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'InitVelocity',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuRamp_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRamp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for Ramp','Ramp',1,{num2str(handles.Ramp)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.Ramp = newv; 
        msg = ['Ramp = ', num2str(handles.Ramp)];
        set(handles.mnuRamp,'Label',msg);
        set(handles.txtMessage,'String',msg);
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'Ramp',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for Log','Log',1,{num2str(handles.Log)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.Log = newv; 
        msg = ['Log = ', num2str(handles.Log)];
        set(handles.mnuLog,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'Log',newv);
        end
        guidata(hObject, handles);      
    end
end


function txtMessage_Callback(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMessage as text
%        str2double(get(hObject,'String')) returns contents of txtMessage as a double


% --- Executes during object creation, after setting all properties.
function txtMessage_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function mnuLL_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes during object deletion, before destroying properties.
function figFilterWheel_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figFilterWheel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

fw = handles.fw;
if(strcmp(class(fw),'FilterWheel')) 
    delete(fw);
    clear fw;
    handles.fw = 0;
end
if(handles.PortObjVar == 1)
    s = handles.PortObj;
    if(strcmp(class(s),'serial'))
        [error] = EZStepperCloseSerial(s);
        set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
        handles.PortObjVar = 0;
    end
end
guidata(hObject,handles); % store the changes


% --------------------------------------------------------------------
function mnuViewLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuViewLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
log = EZStepperLog();
log

% --------------------------------------------------------------------
function mnuClearLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuClearLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
EZStepperClearLog;

% --------------------------------------------------------------------
function mnuOpenCOM_Callback(hObject, eventdata, handles)
% hObject    handle to mnuOpenCOM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[s,error] = EZStepperOpenSerial(handles.COMPort);
if(error==0)
    handles.PortObj = s;
    set(hObject,'Enable','off');
    set(handles.mnuPort,'Enable','off');
    set(handles.mnuCreateFW,'Enable','on');
end
msg = ['Open Port ' handles.COMPort ', error = ' num2str(error)];
set(handles.txtMessage,'String',msg);
guidata(hObject,handles); % store the changes


% --------------------------------------------------------------------
function mnuCreateFW_Callback(hObject, eventdata, handles)
% hObject    handle to mnuCreateFW (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%SAVE PARAMETERS
COMPort = handles.COMPort;
ControllerType = handles.ControllerType;
ControllerName = handles.ControllerName;
MotorSteps = handles.MotorSteps;
FilterPositions = handles.FilterPositions;
OffsetFromHome = handles.OffsetFromHome;
HoldCurrent = handles.HoldCurrent;
RunCurrent = handles.RunCurrent;
StepDivide = handles.StepDivide;
SlewVelocity = handles.SlewVelocity;
InitVelocity = handles.InitVelocity;
Ramp = handles.Ramp;
Log = handles.Log;

%CREATE OBJECT
try
    fw = FilterWheel('PortObj', handles.PortObj, 'ControllerType', handles.ControllerType, ...
        'ControllerName', handles.ControllerName, 'MotorSteps', handles.MotorSteps, ...
        'FilterPositions', handles.FilterPositions, 'OffsetFromHome', handles.OffsetFromHome,  ...
        'HoldCurrent', handles.HoldCurrent, 'RunCurrent', handles.RunCurrent, ...
        'StepDivide', handles.StepDivide, 'SlewVelocity', handles.SlewVelocity, ...
        'InitVelocity', handles.InitVelocity, 'Ramp', handles.Ramp, 'Log', handles.Log);
    handles.fw = fw;
    errfw = get(fw,'LastErr');
catch ER
    errfw = -99; 
end
if(errfw == 0)
    save FilterWheel.mat COMPort ControllerType ControllerName MotorSteps ...
    FilterPositions OffsetFromHome HoldCurrent RunCurrent StepDivide ...
    SlewVelocity InitVelocity Ramp Log;
    msg = ['FW Object Created, LastErr = ' num2str(errfw)];
    set(handles.txtMessage,'String',msg);
    set(hObject,'Enable','off');
    guidata(hObject,handles); % store the changes
    %ENABLE ACTION BUTTONS
    set(handles.btnHome,'Enable','on'); 
    %DISABLE CHANGING PARAMETERS THAT SHOULD NOT CHANGE AFTER OBJECT CREATION
    set(handles.mnuControllerType,'Enable','off');
    set(handles.mnuControllerName,'Enable','off');
    set(handles.mnuMotorSteps,'Enable','off');
    set(handles.mnuFilterPositions,'Enable','off');
    %FORM FILTER POPUP MENU
    filt_list = cell(1,fw.FilterPositions);
    for i=1:fw.FilterPositions
        filt_list(i)= {['Filter ' num2str(i)]};
    end
    set(handles.popF,'String',filt_list);
else
    msg = ['Error creating FW Obj., LastErr=' num2str(errfw)];
    set(handles.txtMessage,'String',msg);
end


% --- Executes on button press in btnReadPos.
function btnReadPos_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fw = handles.fw;
[filt, err, mpos] = WheelPos(fw);
msg = ['Filter=' num2str(filt) ', Pos.=' num2str(mpos) ', Error=' num2str(err)];
set(handles.txtMessage,'String',msg);


function txtPos_Callback(hObject, eventdata, handles)
% hObject    handle to txtPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtPos as text
%        str2double(get(hObject,'String')) returns contents of txtPos as a double


% --- Executes during object creation, after setting all properties.
function txtPos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnHome.
function btnHome_Callback(hObject, eventdata, handles)
% hObject    handle to btnHome (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fw = handles.fw;
set(handles.txtMessage,'String','Homing ...');
drawnow
err = WheelHome(fw);
set(handles.txtMessage,'String',['Home finished, error = ' num2str(err)]);
if(err == 0)
    set(handles.popF,'Enable','on');
    set(handles.popF,'Value',1);
    set(handles.btnReadPos,'Enable','on');
    set(handles.btnNextPos,'Enable','on'); 
    set(handles.btnPrevPos,'Enable','on'); 
end

% --------------------------------------------------------------------
function mnuOffsetFromHome_Callback(hObject, eventdata, handles)
% hObject    handle to mnuOffsetFromHome (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for OffsetFromHome','OffsetFromHome',1,{num2str(handles.OffsetFromHome)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.OffsetFromHome = newv; 
        msg = ['OffsetFromHome = ', num2str(handles.OffsetFromHome)];
        set(handles.mnuOffsetFromHome,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fw = handles.fw;
        if(strcmp(class(fw),'FilterWheel')) 
           set(fw,'OffsetFromHome',newv);
        end
        guidata(hObject, handles);      
    end
end


% --- Executes on selection change in popF.
function popF_Callback(hObject, eventdata, handles)
% hObject    handle to popF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popF contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popF
val = get(hObject,'Value');
string_list = get(hObject,'String');
sel_str = string_list{val}; % convert from cell array to string
k = findstr(' ',sel_str);
ind = k(1);
sfilt = sel_str(ind+1:length(sel_str)); 
filt = str2double(sfilt);
fw = handles.fw;
err = WheelMove(fw, filt);
msg = ['Moving to filter ' num2str(filt) ', Error = ' num2str(err)];
set(handles.txtMessage,'String',msg); 

% --- Executes during object creation, after setting all properties.
function popF_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnNextPos.
function btnNextPos_Callback(hObject, eventdata, handles)
% hObject    handle to btnNextPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fw = handles.fw;
err = WheelNext(fw);
fn = get(handles.popF,'Value');
fn = fn + 1;
if(fn > fw.FilterPositions), fn = 1; end
set(handles.popF,'Value',fn);
msg = ['Moving to filter ' num2str(fn) ', Error = ' num2str(err)];
set(handles.txtMessage,'String',msg); 


% --- Executes on button press in btnPrevPos.
function btnPrevPos_Callback(hObject, eventdata, handles)
% hObject    handle to btnPrevPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fw = handles.fw;
err = WheelPrev(fw);
fn = get(handles.popF,'Value');
fn = fn - 1;
if(fn < 1), fn = fw.FilterPositions; end
set(handles.popF,'Value',fn);
msg = ['Moving to filter ' num2str(fn) ', Error = ' num2str(err)];
set(handles.txtMessage,'String',msg); 


% --------------------------------------------------------------------
function mnuSavePar_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSavePar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
COMPort = handles.COMPort;
ControllerType = handles.ControllerType;
ControllerName = handles.ControllerName;
MotorSteps = handles.MotorSteps;
FilterPositions = handles.FilterPositions;
OffsetFromHome = handles.OffsetFromHome;
HoldCurrent = handles.HoldCurrent;
RunCurrent = handles.RunCurrent;
StepDivide = handles.StepDivide;
SlewVelocity = handles.SlewVelocity;
InitVelocity = handles.InitVelocity;
Ramp = handles.Ramp;
Log = handles.Log;
save FilterWheel.mat COMPort ControllerType ControllerName MotorSteps ...
    FilterPositions OffsetFromHome HoldCurrent RunCurrent StepDivide ...
    SlewVelocity InitVelocity Ramp Log;
set(handles.txtMessage,'String','Parameters saved');
