function varargout = FocusDrive_UI(varargin)
% FOCUSDRIVE_UI M-file for FocusDrive_UI.fig
%      FOCUSDRIVE_UI, by itself, creates a new FOCUSDRIVE_UI or raises the existing
%      singleton*.
%
%      H = FOCUSDRIVE_UI returns the handle to a new FOCUSDRIVE_UI or the handle to
%      the existing singleton*.
%
%      FOCUSDRIVE_UI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FOCUSDRIVE_UI.M with the given input arguments.
%
%      FOCUSDRIVE_UI('Property','Value',...) creates a new FOCUSDRIVE_UI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FocusDrive_UI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FocusDrive_UI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FocusDrive_UI

% Last Modified by GUIDE v2.5 06-May-2009 13:11:12

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FocusDrive_UI_OpeningFcn, ...
                   'gui_OutputFcn',  @FocusDrive_UI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FocusDrive_UI is made visible.
function FocusDrive_UI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FocusDrive_UI (see VARARGIN)

% Choose default command line output for FocusDrive_UI
handles.output = hObject;

%ADD FIELDS IN handles WITH DEFAULT VALUES
handles.fd = 0;
handles.PortObj = NaN; %port object;
handles.COMPort = 'COM4';
handles.PortObjVar = 1; 
handles.ControllerType = 'EZHR17'; %supported: EZHR17
handles.ControllerTypeVar = 1;
handles.ControllerName = 2; %name or number of controller on this port
handles.ControllerNameVar = 1;
handles.StrokePerRotation = 100; % up/down travel for one full turn in microns; typically 100 um.
handles.StrokePerRotationVar = 1;
handles.MotorSteps = 400; %physical steps in the motor; typically 400
handles.MotorStepsVar = 1;
handles.WithLimits = 0; %1 - if has limits; 0 - without limits
handles.WithLimitsVar = 1;
handles.HoldCurrent = 5; %current when not moving; in % of full (2A for EZHR17); typically 5%
handles.HoldCurrentVar = 1;
handles.RunCurrent = 25; %current when moving; in % of full (2A for EZHR17); typically 25%
handles.RunCurrentVar = 1;
handles.StepDivide = 256; %number of microsteps per step; typically 256
handles.StepDivideVar = 1;
handles.SlewVelocity = 500; %slew (max) velocity in microns/sec 
handles.SlewVelocityVar = 1;
handles.InitVelocity = 10; %initial velocity in microns/sec 
handles.InitVelocityVar = 1;
handles.Ramp = 0.5; %acceleration (deceleration) in microns/sec^2 
handles.RampVar = 1;
handles.Log = 1; %0 - do not accumulate log; 1 - accumulate log
handles.LogVar = 1;

%READ PARAMETER VALUES
try
    load FocusDrive.mat;
    handles.COMPort = COMPort;
    handles.ControllerType = ControllerType;
    handles.ControllerName = ControllerName;
    handles.StrokePerRotation = StrokePerRotation;
    handles.MotorSteps = MotorSteps;
    handles.WithLimits = WithLimits;
    handles.HoldCurrent = HoldCurrent;
    handles.RunCurrent = RunCurrent;
    handles.StepDivide = StepDivide;
    handles.SlewVelocity = SlewVelocity;
    handles.InitVelocity = InitVelocity;
    handles.Ramp = Ramp;
    handles.Log = Log;
    set(handles.txtMessage,'String','Parameters read'); 
catch ME
   set(handles.txtMessage,'String','Parameter file was not read; using defaults'); 
end

%PARSE INPUT LINE
property_argin = varargin;
while (length(property_argin) >= 2)
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'PortObj'
        handles.PortObj = val; handles.PortObjVar = 0; 
    case 'ControllerType'
        handles.ControllerType = val; handles.ControllerTypeVar = 0;
    case 'ControllerName'
        handles.ControllerName = val; handles.ControllerNameVar = 0;
    case 'StrokePerRotation'
        handles.StrokePerRotation = val; handles.StrokePerRotationVar = 0;
    case 'MotorSteps'
        handles.MotorSteps = val; handles.MotorStepsVar = 0;
    case 'WithLimits'
        handles.WithLimits = val; handles.WithLimitsVar = 0;
    case 'HoldCurrent'
        handles.HoldCurrent = val; handles.HoldCurrentVar = 0;
    case 'RunCurrent'
        handles.RunCurrent = val; handles.RunCurrentVar = 0;
    case 'StepDivide'
        handles.StepDivide = val; handles.StepDivideVar = 0;
    case 'SlewVelocity'
        handles.SlewVelocity = val; handles.SlewVelocityVar = 0;
    case 'InitVelocity'
        handles.InitVelocity = val; handles.InitVelocityVar = 0;
    case 'Ramp'
        handles.Ramp = val; handles.RampVar = 0;
    case 'Log'
        handles.Log = val; handles.LogVar = 0;
    end
end

%Form menu labels
if(handles.PortObjVar == 1)
    set(handles.mnuPort,'Label',['Port = ', handles.COMPort]);
else    
    s = handles.PortObj; 
    if(strcmp(class(s),'serial'))
        handles.COMPort = s.Port; 
    else
        handles.COMPort = 'not a serial port';
    end
    set(handles.mnuPort,'Label',['Port = ', handles.COMPort]);
    set(handles.mnuPort,'Enable','off');
    set(handles.mnuOpenCOM,'Enable','off');
    set(handles.mnuCreateFD,'Enable','on');
end    
set(handles.mnuControllerType,'Label', ['ControllerType = ' handles.ControllerType]);
if(handles.ControllerTypeVar == 0), set(handles.mnuControllerType,'Enable','off'); end
set(handles.mnuControllerName,'Label', ['ControllerName = ' num2str(handles.ControllerName)]);
if(handles.ControllerNameVar == 0), set(handles.mnuControllerName,'Enable','off'); end
set(handles.mnuStrokePerRotation,'Label', ['StrokePerRotation = ' num2str(handles.StrokePerRotation)]);
if(handles.StrokePerRotationVar == 0), set(handles.mnuStrokePerRotation,'Enable','off'); end
set(handles.mnuMotorSteps,'Label', ['MotorSteps = ' num2str(handles.MotorSteps)]);
if(handles.MotorStepsVar == 0), set(handles.mnuMotorSteps,'Enable','off'); end
set(handles.mnuWithLimits,'Label', ['WithLimits = ' num2str(handles.WithLimits)]);
if(handles.WithLimitsVar == 0), set(handles.mnuWithLimits,'Enable','off'); end
set(handles.mnuHoldCurrent,'Label', ['HoldCurrent = ' num2str(handles.HoldCurrent)]);
if(handles.HoldCurrentVar == 0), set(handles.mnuHoldCurrent,'Enable','off'); end
set(handles.mnuRunCurrent,'Label', ['RunCurrent = ' num2str(handles.RunCurrent)]);
if(handles.RunCurrentVar == 0), set(handles.mnuRunCurrent,'Enable','off'); end
set(handles.mnuStepDivide,'Label', ['StepDivide = ' num2str(handles.StepDivide)]);
if(handles.StepDivideVar == 0), set(handles.mnuStepDivide,'Enable','off'); end
set(handles.mnuSlewVelocity,'Label', ['SlewVelocity = ' num2str(handles.SlewVelocity)]);
if(handles.SlewVelocityVar == 0), set(handles.mnuSlewVelocity,'Enable','off'); end
set(handles.mnuInitVelocity,'Label', ['InitVelocity = ' num2str(handles.InitVelocity)]);
if(handles.InitVelocityVar == 0), set(handles.mnuInitVelocity,'Enable','off'); end
set(handles.mnuRamp,'Label', ['Ramp = ' num2str(handles.Ramp)]);
if(handles.RampVar == 0), set(handles.mnuRamp,'Enable','off'); end
set(handles.mnuLog,'Label', ['Log = ' num2str(handles.Log)]);
if(handles.LogVar == 0), set(handles.mnuLog,'Enable','off'); end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FocusDrive_UI wait for user response (see UIRESUME)
% uiwait(handles.figFocusDrive);


% --- Outputs from this function are returned to the command line.
function varargout = FocusDrive_UI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function mnuPar_Callback(hObject, eventdata, handles)
% hObject    handle to mnuPar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuInit_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function mnuPort_Callback(hObject, eventdata, handles)
% hObject    handle to mnuPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
newc = inputdlg('Enter new value for COM Port','Port',1,{handles.COMPort});
drawnow;
if(~isempty(newc)) 
    handles.COMPort = newc{1}; 
    msg = ['Port = ', handles.COMPort];
    set(handles.mnuPort,'Label',msg);
    set(handles.txtMessage,'String',msg); 
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function mnuControllerType_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%ONLY ONE SUPPORTED

% --------------------------------------------------------------------
function mnuControllerName_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for ControllerName (Number)','ControllerName',1,{num2str(handles.ControllerName)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.ControllerName = newv; 
        msg = ['ControllerName = ', num2str(handles.ControllerName)];
        set(handles.mnuControllerName,'Label',msg);
        set(handles.txtMessage,'String',msg);
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuStrokePerRotation_Callback(hObject, eventdata, handles)
% hObject    handle to mnuStrokePerRotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for StrokePerRotation','StrokePerRotation',1,{num2str(handles.StrokePerRotation)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.StrokePerRotation = newv; 
        msg = ['StrokePerRotation = ', num2str(handles.StrokePerRotation)];
        set(handles.mnuStrokePerRotation,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuMotorSteps_Callback(hObject, eventdata, handles)
% hObject    handle to mnuMotorSteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for MotorSteps','MotorSteps',1,{num2str(handles.MotorSteps)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.MotorSteps = newv; 
        msg = ['MotorSteps = ', num2str(handles.MotorSteps)];
        set(handles.mnuMotorSteps,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end

% --------------------------------------------------------------------
function mnuWithLimits_Callback(hObject, eventdata, handles)
% hObject    handle to mnuWithLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for WithLimits','WithLimits',1,{num2str(handles.WithLimits)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.WithLimits = newv; 
        msg = ['WithLimits = ', num2str(handles.WithLimits)];
        set(handles.mnuWithLimits,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end

% --------------------------------------------------------------------
function mnuHoldCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to mnuHoldCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for HoldCurrent','HoldCurrent',1,{num2str(handles.HoldCurrent)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.HoldCurrent = newv; 
        msg = ['HoldCurrent = ', num2str(handles.HoldCurrent)];
        set(handles.mnuHoldCurrent,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'HoldCurrent',newv);
        end
        guidata(hObject, handles);      
    end
end

% --------------------------------------------------------------------
function mnuRunCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRunCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for RunCurrent','RunCurrent',1,{num2str(handles.RunCurrent)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.RunCurrent = newv; 
        msg = ['RunCurrent = ', num2str(handles.RunCurrent)];
        set(handles.mnuRunCurrent,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'RunCurrent',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuStepDivide_Callback(hObject, eventdata, handles)
% hObject    handle to mnuStepDivide (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for StepDivide','StepDivide',1,{num2str(handles.StepDivide)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.StepDivide = newv; 
        msg = ['StepDivide = ', num2str(handles.StepDivide)];
        set(handles.mnuStepDivide,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'StepDivide',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuSlewVelocity_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSlewVelocity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for SlewVelocity','SlewVelocity',1,{num2str(handles.SlewVelocity)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.SlewVelocity = newv; 
        msg = ['SlewVelocity = ', num2str(handles.SlewVelocity)];
        set(handles.mnuSlewVelocity,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'SlewVelocity',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuInitVelocity_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInitVelocity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for InitVelocity','InitVelocity',1,{num2str(handles.InitVelocity)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.InitVelocity = newv; 
        msg = ['InitVelocity = ', num2str(handles.InitVelocity)];
        set(handles.mnuInitVelocity,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'InitVelocity',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuRamp_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRamp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for Ramp','Ramp',1,{num2str(handles.Ramp)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.Ramp = newv; 
        msg = ['Ramp = ', num2str(handles.Ramp)];
        set(handles.mnuRamp,'Label',msg);
        set(handles.txtMessage,'String',msg);
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'Ramp',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for Log','Log',1,{num2str(handles.Log)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.Log = newv; 
        msg = ['Log = ', num2str(handles.Log)];
        set(handles.mnuLog,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        fd = handles.fd;
        if(strcmp(class(fd),'FocusDrive')) 
           set(fd,'Log',newv);
        end
        guidata(hObject, handles);      
    end
end


function txtMessage_Callback(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMessage as text
%        str2double(get(hObject,'String')) returns contents of txtMessage as a double


% --- Executes during object creation, after setting all properties.
function txtMessage_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function mnuLL_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes during object deletion, before destroying properties.
function figFocusDrive_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figFocusDrive (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

fd = handles.fd;
if(strcmp(class(fd),'FocusDrive')) 
    delete(fd);
    clear fd;
    handles.fd = 0;
end
if(handles.PortObjVar == 1)
    s = handles.PortObj;
    if(strcmp(class(s),'serial'))
        [error] = EZStepperCloseSerial(s);
        set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
        handles.PortObjVar = 0;
    end
end
guidata(hObject,handles); % store the changes


% --------------------------------------------------------------------
function mnuViewLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuViewLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
log = EZStepperLog();
log

% --------------------------------------------------------------------
function mnuClearLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuClearLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
EZStepperClearLog;

% --------------------------------------------------------------------
function mnuOpenCOM_Callback(hObject, eventdata, handles)
% hObject    handle to mnuOpenCOM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[s,error] = EZStepperOpenSerial(handles.COMPort);
if(error==0)
    handles.PortObj = s;
    set(hObject,'Enable','off');
    set(handles.mnuPort,'Enable','off');
    set(handles.mnuCreateFD,'Enable','on');
end
msg = ['Open Port ' handles.COMPort ', error = ' num2str(error)];
set(handles.txtMessage,'String',msg);
guidata(hObject,handles); % store the changes


% --------------------------------------------------------------------
function mnuCreateFD_Callback(hObject, eventdata, handles)
% hObject    handle to mnuCreateFD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%SAVE PARAMETERS
COMPort = handles.COMPort;
ControllerType = handles.ControllerType;
ControllerName = handles.ControllerName;
StrokePerRotation = handles.StrokePerRotation;
MotorSteps = handles.MotorSteps;
WithLimits = handles.WithLimits;
HoldCurrent = handles.HoldCurrent;
RunCurrent = handles.RunCurrent;
StepDivide = handles.StepDivide;
SlewVelocity = handles.SlewVelocity;
InitVelocity = handles.InitVelocity;
Ramp = handles.Ramp;
Log = handles.Log;

%CREATE OBJECT
try
    fd = FocusDrive('PortObj', handles.PortObj, 'ControllerType', handles.ControllerType, ...
        'ControllerName', handles.ControllerName, 'StrokePerRotation', handles.StrokePerRotation, ...
        'MotorSteps', handles.MotorSteps, 'WithLimits', handles.WithLimits, ...
        'HoldCurrent', handles.HoldCurrent, 'RunCurrent', handles.RunCurrent, ...
        'StepDivide', handles.StepDivide, 'SlewVelocity', handles.SlewVelocity, ...
        'InitVelocity', handles.InitVelocity, 'Ramp', handles.Ramp, 'Log', handles.Log);
    handles.fd = fd;
    errfd = get(fd,'LastErr');
catch ER
    errfd = -99; 
end
if(errfd==0)
    save FocusDrive.mat COMPort ControllerType ControllerName StrokePerRotation MotorSteps ...
    WithLimits HoldCurrent RunCurrent StepDivide SlewVelocity InitVelocity Ramp Log;
    msg = ['FD Object Created, LastErr = ' num2str(errfd)];
    set(handles.txtMessage,'String',msg);
    set(hObject,'Enable','off');
    guidata(hObject,handles); % store the changes
    %ENABLE ACTION BUTTONS
    set(handles.btnUpCoarse,'Enable','on');
    set(handles.btnDownCoarse,'Enable','on');
    set(handles.btnUpFine,'Enable','on');
    set(handles.btnDownFine,'Enable','on');
    set(handles.btnReadPos,'Enable','on');
    if (WithLimits==1), set(handles.btnHome,'Enable','on'); end
    %DISABLE CHANGING PARAMETERS THAT SHOULD NOT CHANGE AFTER OBJECT CREATION
    set(handles.mnuControllerType,'Enable','off');
    set(handles.mnuControllerName,'Enable','off');
    set(handles.mnuStrokePerRotation,'Enable','off');
    set(handles.mnuMotorSteps,'Enable','off');
    set(handles.mnuWithLimits,'Enable','off');
else
    msg = ['Error creating FD Obj., LastErr=' num2str(errfd)];
    set(handles.txtMessage,'String',msg);    
end

% --- Executes on button press in btnUpCoarse.
function btnUpCoarse_Callback(hObject, eventdata, handles)
% hObject    handle to btnUpCoarse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fd = handles.fd;
travel = str2double(get(handles.txtStepCoarse,'String'));
if isnan(travel), set(handles.txtMessage,'String','Not a number'); return; end
err = ZRelative(fd,-travel);
msg = ['Z Relative ' num2str(-travel) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);

% --- Executes on button press in btnDownCoarse.
function btnDownCoarse_Callback(hObject, eventdata, handles)
% hObject    handle to btnDownCoarse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fd = handles.fd;
travel = str2double(get(handles.txtStepCoarse,'String'));
if isnan(travel), set(handles.txtMessage,'String','Not a number'); return; end
err = ZRelative(fd,travel);
msg = ['Z Relative ' num2str(travel) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);


% --- Executes on button press in btnUpFine.
function btnUpFine_Callback(hObject, eventdata, handles)
% hObject    handle to btnUpFine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fd = handles.fd;
travel = str2double(get(handles.txtStepFine,'String'));
if isnan(travel), set(handles.txtMessage,'String','Not a number'); return; end
err = ZRelative(fd,-travel);
msg = ['Z Relative ' num2str(-travel) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);


% --- Executes on button press in btnDownFine.
function btnDownFine_Callback(hObject, eventdata, handles)
% hObject    handle to btnDownFine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fd = handles.fd;
travel = str2double(get(handles.txtStepFine,'String'));
if isnan(travel), set(handles.txtMessage,'String','Not a number'); return; end
err = ZRelative(fd,travel);
msg = ['Z Relative ' num2str(travel) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);



function txtStepCoarse_Callback(hObject, eventdata, handles)
% hObject    handle to txtStepCoarse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtStepCoarse as text
%        str2double(get(hObject,'String')) returns contents of txtStepCoarse as a double


% --- Executes during object creation, after setting all properties.
function txtStepCoarse_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtStepCoarse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtStepFine_Callback(hObject, eventdata, handles)
% hObject    handle to txtStepFine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtStepFine as text
%        str2double(get(hObject,'String')) returns contents of txtStepFine as a double


% --- Executes during object creation, after setting all properties.
function txtStepFine_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtStepFine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnReadPos.
function btnReadPos_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fd = handles.fd;
[pos, err] = ZPos(fd);
msg = ['Z Read Position, error = ' num2str(err)];
set(handles.txtMessage,'String',msg);
set(handles.txtPos,'String',num2str(pos));


function txtPos_Callback(hObject, eventdata, handles)
% hObject    handle to txtPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtPos as text
%        str2double(get(hObject,'String')) returns contents of txtPos as a double


% --- Executes during object creation, after setting all properties.
function txtPos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnHome.
function btnHome_Callback(hObject, eventdata, handles)
% hObject    handle to btnHome (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fd = handles.fd;
SlewVelocity = get(fd,'SlewVelocity');
homespeed = str2double(get(handles.txtHomeSpeed,'String'));
if isnan(homespeed), homespeed = SlewVelocity; end
set(handles.txtMessage,'String','Homing ...');
drawnow
err = ZHomeComplete(fd, homespeed);
set(handles.txtMessage,'String',['Home finished, error = ' num2str(err)]);

function txtHomeSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to txtHomeSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtHomeSpeed as text
%        str2double(get(hObject,'String')) returns contents of txtHomeSpeed as a double


% --- Executes during object creation, after setting all properties.
function txtHomeSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtHomeSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function mnuSavePar_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSavePar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
COMPort = handles.COMPort;
ControllerType = handles.ControllerType;
ControllerName = handles.ControllerName;
StrokePerRotation = handles.StrokePerRotation;
MotorSteps = handles.MotorSteps;
WithLimits = handles.WithLimits;
HoldCurrent = handles.HoldCurrent;
RunCurrent = handles.RunCurrent;
StepDivide = handles.StepDivide;
SlewVelocity = handles.SlewVelocity;
InitVelocity = handles.InitVelocity;
Ramp = handles.Ramp;
Log = handles.Log;

save FocusDrive.mat COMPort ControllerType ControllerName StrokePerRotation MotorSteps ...
    WithLimits HoldCurrent RunCurrent StepDivide SlewVelocity InitVelocity Ramp Log;

